﻿using System.ComponentModel;
using System.Threading;
using System.Windows;
using System.Windows.Controls;

namespace BusyIndicatorDelay
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        private BackgroundWorker _backgroundWorker;
        public MainWindow()
        {
            InitializeComponent();

            _backgroundWorker = new BackgroundWorker();
            _backgroundWorker.DoWork += _backgroundWorker_DoWork;
            _backgroundWorker.RunWorkerCompleted += _backgroundWorker_RunWorkerCompleted;
        }

        private void _backgroundWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            BusyIndicator.IsBusy = false;
        }

        private void _backgroundWorker_DoWork(object sender, DoWorkEventArgs e)
        {
            Thread.Sleep(5000);
        }

        private void OnButtonClick(object sender, RoutedEventArgs e)
        {
            var button = e.Source as Button;
            if (button != null && button.Name.Equals("BtnStart"))
            {
                BusyIndicator.IsBusy = true;
                _backgroundWorker.RunWorkerAsync();
            }
            else
            {
                BusyIndicator.IsBusy = false;
            }
        }
    }
}
